<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="650">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="120px"
    >
<!--      <el-row>-->
<!--        <el-col :span="15">-->
<!--          <el-form-item label="锁柜编号" prop="cabinetCode">-->
<!--            <el-input-->
<!--              v-model="formData.cabinetCode"-->
<!--              placeholder="请输入锁柜编号"-->
<!--              class="!w-240px"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--        <el-col :span="8">-->
<!--          <el-form-item label-width="80">-->
<!--            <el-switch-->
<!--              v-model="autoGenFlag"-->
<!--              active-color="#13ce66"-->
<!--              active-text="自动生成"-->
<!--              @change="handleAutoGenChange"-->
<!--              v-if="formType !== 'view'"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--      </el-row>-->
      <el-form-item label="锁柜名称" prop="cabinetName">
        <el-input
          v-model="formData.cabinetName"
          placeholder="请输入锁柜名称"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="岗位序号" prop="workstationId">
        <el-tree-select
          v-model="formData.workstationId"
          :data="workstationOptions"
          :props="{ label: 'workstationName', value: 'id', children: 'children' }"
          placeholder="请选择岗位"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="硬件ID" prop="hardwareId">
        <el-select
          v-model="formData.hardwareId"
          placeholder="请选择硬件ID"
          clearable
          class="!w-240px"
          @change="handleSelectHardware"
        >
          <el-option
            v-for="dict in hardwareOptions"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="是否在线" prop="isOnline">
        <el-radio-group v-model="formData.isOnline">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.ISONLINE_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.CANBINET_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-row>
        <el-col :span="10">
          <el-form-item label="图标" prop="cabinetIcon">
            <UploadImg
              v-model="formData.cabinetIcon"
              :limit="1"
              height="64px"
              width="64px"
            />
          </el-form-item>
        </el-col>
        <el-col :span="10">
          <el-form-item label="图片" prop="cabinetPicture">
            <UploadImg
              v-model="formData.cabinetPicture"
              :limit="1"
              height="64px"
              width="64px"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="备注" prop="remark">
        <el-input
          v-model="formData.remark"
          placeholder="请输入备注"
          class="!w-240px"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import { ref, reactive } from 'vue'
import { DICT_TYPE, getIntDictOptions,getStrDictOptions} from '@/utils/dict'
import { handleTree } from '@/utils/tree'
import * as LockCabinetApi from '@/api/hw/hardware/lockCabinet/index'
import * as HardwareApi from '@/api/hw/hardware/information/index'
import * as MarsDeptApi from '@/api/system/marsdept/index'
// import * as AutocodeApi from '@/api/system/autocode/rule'

defineOptions({ name: 'LockCabinetForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const autoGenFlag = ref(false) // 是否自动生成编码

const formData = ref({
  cabinetId: undefined,
  cabinetCode: '',
  cabinetName: '',
  workstationId: undefined,
  hardwareId: undefined,
  isOnline: '1',
  status: '1',
  cabinetIcon: '',
  cabinetPicture: '',
  remark: ''
})

const formRules = reactive({
  // cabinetCode: [{ required: true, message: '锁柜编码不能为空', trigger: 'blur' }],
  cabinetName: [{ required: true, message: '锁柜名称不能为空', trigger: 'blur' }],
  hardwareId: [{ required: true, message: '硬件ID不能为空', trigger: 'blur' }],
  workstationId: [{ required: true, message: '岗位序号不能为空', trigger: 'blur' }]
})

const formRef = ref() // 表单 Ref
const hardwareOptions = ref([]) // 硬件选项
const workstationOptions = ref([]) // 岗位选项

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await LockCabinetApi.selectIsLockCabinetById(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await LockCabinetApi.insertIsLockCabinet(data)
      message.success(t('common.createSuccess'))
    } else {
      await LockCabinetApi.updateIsLockCabinet(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    cabinetId: undefined,
    cabinetCode: '',
    cabinetName: '',
    workstationId: undefined,
    hardwareId: undefined,
    isOnline: '1',
    status: '1',
    cabinetIcon: '',
    cabinetPicture: '',
    remark: ''
  }
  autoGenFlag.value = false
  formRef.value?.resetFields()
}

/** 自动生成编码 */
// const handleAutoGenChange = async (value: boolean) => {
//   if (value) {
//     formData.value.cabinetCode = await AutocodeApi.genCode('CABINET_CODE')
//   } else {
//     formData.value.cabinetCode = ''
//   }
// }

/** 选择硬件 */
const handleSelectHardware = (value: string) => {
  formData.value.hardwareId = value
}

/** 获取硬件列表 */
const getHardwareList = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await HardwareApi.listHardware(data)
  console.log(response,'aa')
  hardwareOptions.value = response.list.map(item => ({
    value: item.id,
    label: item.hardwareName
  }))
}

/** 获取岗位列表 */
const getWorkstationList = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await MarsDeptApi.listMarsDept(data)
  workstationOptions.value = handleTree(response.list, 'id', 'parentId')
}

/** 初始化 **/
onMounted(async () => {
  await getHardwareList()
  await getWorkstationList()
})
</script>
